---
title: grid-auto-flow
slug: Web/CSS/grid-auto-flow
tags:
  - CSS
  - CSS Grid
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<p>The <strong><code>grid-auto-flow</code></strong> CSS property controls how the auto-placement algorithm works, specifying exactly how auto-placed items get flowed into the grid.</p>

<div>{{EmbedInteractiveExample("pages/css/grid-auto-flow.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
grid-auto-flow: row;
grid-auto-flow: column;
grid-auto-flow: dense;
grid-auto-flow: row dense;
grid-auto-flow: column dense;

/* Global values */
grid-auto-flow: inherit;
grid-auto-flow: initial;
grid-auto-flow: unset;
</pre>

<p>This property may take one of two forms:</p>

<ul>
	<li>a single keyword: one of <code>row</code>, <code>column</code>, or <code>dense</code>.</li>
	<li>two keywords: <code>row dense</code> or <code>column dense</code>.</li>
</ul>

<h3 id="Values">Values</h3>

<dl>
	<dt><code>row</code></dt>
	<dd>Items are placed by filling each row in turn, adding new rows as necessary. If neither <code>row</code> nor <code>column</code> is provided, <code>row</code> is assumed.</dd>
	<dt><code>column</code></dt>
	<dd>Items are placed by filling each column in turn, adding new columns as necessary.</dd>
	<dt><code>dense</code></dt>
	<dd>"dense" packing algorithm attempts to fill in holes earlier in the grid, if smaller items come up later. This may cause items to appear out-of-order, when doing so would fill in holes left by larger items.</dd>
	<dd>
	<p>If it is omitted, a "sparse" algorithm is used, where the placement algorithm only ever moves "forward" in the grid when placing items, never backtracking to fill holes. This ensures that all of the auto-placed items appear "in order", even if this leaves holes that could have been filled by later items.</p>
	</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_grid_auto-placement">Setting grid auto-placement</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="grid"&gt;
  &lt;div id="item1"&gt;&lt;/div&gt;
  &lt;div id="item2"&gt;&lt;/div&gt;
  &lt;div id="item3"&gt;&lt;/div&gt;
  &lt;div id="item4"&gt;&lt;/div&gt;
  &lt;div id="item5"&gt;&lt;/div&gt;
&lt;/div&gt;
&lt;select id="direction"&gt;
  &lt;option value="column"&gt;column&lt;/option&gt;
  &lt;option value="row"&gt;row&lt;/option&gt;
&lt;/select&gt;
&lt;input id="dense" type="checkbox"&gt;
&lt;label for="dense"&gt;dense&lt;/label&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[7] notranslate">#grid {
  height: 200px;
  width: 200px;
  display: grid;
  gap: 10px;
  grid-template: repeat(4, 1fr) / repeat(2, 1fr);
  grid-auto-flow: column;  /* or 'row', 'row dense', 'column dense' */
}

#item1 {
  background-color: lime;
  grid-row-start: 3;
}

#item2 {
  background-color: yellow;
}

#item3 {
  background-color: blue;
}

#item4 {
  grid-column-start: 2;
  background-color: red;
}

#item5 {
  background-color: aqua;
}</pre>

<pre class="brush: js; hidden notranslate">function changeGridAutoFlow() {
  var grid = document.getElementById("grid");
  var direction = document.getElementById("direction");
  var dense = document.getElementById("dense");
  var gridAutoFlow = direction.value === "row" ? "row" : "column";

  if (dense.checked) {
    gridAutoFlow += " dense";
  }

  grid.style.gridAutoFlow = gridAutoFlow;
}

const selectElem = document.querySelector('select');
const inputElem = document.querySelector('input');
selectElem.addEventListener('change', changeGridAutoFlow);
inputElem.addEventListener('change', changeGridAutoFlow);
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_grid_auto-placement", "200px", "230px")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS3 Grid", "#propdef-grid-auto-flow", "grid-auto-flow")}}</td>
			<td>{{Spec2("CSS3 Grid")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.grid-auto-flow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>Related CSS properties: {{cssxref("grid-auto-rows")}}, {{cssxref("grid-auto-columns")}}, {{cssxref("grid")}}</li>
	<li>Grid Layout Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Auto-placement_in_CSS_Grid_Layout">Auto-placement in grid layout</a></em></li>
	<li>Video tutorial: <em><a href="http://gridbyexample.com/video/series-auto-placement-order/">Introducing Grid auto-placement and order</a></em></li>
</ul>

<section class="Quick_links" id="Quick_Links">
<ol>
	<li><a href="/en-US/docs/Web/CSS"><strong>CSS</strong></a></li>
	<li><a href="/en-US/docs/Web/CSS/Reference"><strong>CSS Reference</strong></a></li>
	<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a></li>
	<li data-default-state="open"><a href="#"><strong>Guides</strong></a>
	<ol>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basics concepts of grid layout</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Relationship_of_Grid_Layout">Relationship to other layout methods</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Line-based_Placement_with_CSS_Grid">Line-based placement</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Grid template areas</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Layout_using_Named_Grid_Lines">Layout using named grid lines</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Auto-placement_in_CSS_Grid_Layout">Auto-placement in grid layout</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment in grid layout</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid,_Logical_Values_and_Writing_Modes">Grids, logical values and writing modes</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_Layout_and_Accessibility">CSS Grid Layout and Accessibility</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement">CSS Grid Layout and Progressive Enhancement</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Realizing_common_layouts_using_CSS_Grid_Layout">Realizing common layouts using grids</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Subgrid">Subgrid</a></li>
		<li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Masonry_Layout">Masonry layout</a></li>
	</ol>
	</li>
	<li data-default-state="open"><a href="#"><strong>Properties</strong></a>
	<ol>
		<li><code><a href="/en-US/docs/Web/CSS/align-tracks">align-tracks</a></code>{{Experimental_Inline}}</li>
		<li><code><a href="/en-US/docs/Web/CSS/column-gap">column-gap</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/gap">gap</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid">grid</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-area">grid-area</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-auto-columns">grid-auto-columns</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-auto-flow">grid-auto-flow</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-auto-rows">grid-auto-rows</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-column">grid-column</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-column-end">grid-column-end</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-column-start">grid-column-start</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-row">grid-row</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-row-end">grid-row-end</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-row-start">grid-row-start</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-template">grid-template</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-template-areas">grid-template-areas</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-template-columns">grid-template-columns</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/grid-template-rows">grid-template-rows</a></code></li>
		<li><code><a href="/en-US/docs/Web/CSS/justify-tracks">justify-tracks</a></code>{{Experimental_Inline}}</li>
		<li><code><a href="/en-US/docs/Web/CSS/masonry-auto-flow">masonry-auto-flow</a></code>{{Experimental_Inline}}</li>
		<li><code><a href="/en-US/docs/Web/CSS/row-gap">row-gap</a></code></li>
		<li></li>
	</ol>
	</li>
	<li data-default-state="open"><a href="#"><strong>Glossary</strong></a>
	<ol>
		<li><a href="/en-US/docs/Glossary/Grid_lines">Grid lines</a></li>
		<li><a href="/en-US/docs/Glossary/Grid_tracks">Grid tracks</a></li>
		<li><a href="/en-US/docs/Glossary/Grid_cell">Grid cell</a></li>
		<li><a href="/en-US/docs/Glossary/Grid_areas">Grid areas</a></li>
		<li><a href="/en-US/docs/Glossary/Gutters">Gutters</a></li>
		<li><a href="/en-US/docs/Glossary/Grid_rows">Grid row</a></li>
		<li><a href="/en-US/docs/Glossary/Grid_column">Grid column</a></li>
	</ol>
	</li>
</ol>
</section>
